(in-package :squareball)

;; (defclass plong-gui (plong) ())

;; (defmethod initialize-instance :after ((self plong-gui) &key)
;;   (open-shell self))

;; (defmethod update :before ((self plong-gui))
;;   ;; (let ((ball (find-instances self 'ball)))
;;   ;;   (when ball (destroy (first ball))))
;;   (when (and xelf::*shell* (shell-p self))
;;     (update xelf::*shell*)))

;; (defun test-gui ()
;;   (setf *screen-width* 800)
;;   (setf *screen-height* 450)
;;   (setf *resizable* t)
;;   (setf *scale-output-to-window* nil)
;;   (setf *debug-on-error* nil)
;;   (setf *shell-enabled-p* t)
;;   (setf xelf::*font* "sans-11")
;;   (with-session
;;     (open-project :plong)
;;     (xelf::index-all-images)
;;     (xelf::index-pending-resources)
;;     (xelf::preload-resources)
;;     (let ((plong (make-instance 'xelf::desktop)))
;;       ;; start the buffer running
;;       (switch-to-buffer plong))))
;;       ;; (at-next-update
;; 	;; (add-node (current-buffer) (make-instance 'xelf::resize-buffer-dialog) 200 200)
;; 	;;(xelf::show-buffer-properties-dialog (current-buffer))
;; 	;; (bind-event (current-buffer) '(:f9) 'xelf::toggle-other-windows)
;; 	;;      (start-game plong)))))

(trace xelf::all-images)
(trace xelf::all-buffers)
(trace xelf::project-images)
(trace xelf::open-p)
(trace xelf::evaluate)
(trace xelf::get-property-list)
(trace xelf::apply-properties)
(trace xelf::show-dialog)
(trace xelf::tab)
(trace xelf::find-tab-parent)
(trace xelf::find-tab-proxy)
(trace xelf::position-within-parent)
(trace xelf::show-dialog)
(trace xelf::tap)
(trace xelf::get-property-object-pairs)
(trace xelf::get-property-entries)
;; (trace xelf::resize)
;; (trace xelf::layout)
;; (trace xelf::evaluate-here)
;; (trace xelf::evaluate-expression)
;; (trace xelf::evaluate-output)
;; (trace xelf::layout)
(trace xelf::select)
(trace xelf::unselect)
(trace xelf::toggle-selected)
(trace xelf::backtab)
(trace xelf::handle-event)
(trace xelf::do-show-buffer-properties-dialog)
(trace xelf::show-buffer-properties-dialog)
(trace xelf::close-menus)
(trace xelf::context-menu)
(trace xelf::restore-default-values)
(trace xelf::make-menu)
(trace xelf::make-tree)
(trace xelf::make-halo)
(trace xelf::make-method-menu-item)
(trace xelf::release)
(trace xelf::press)
 (trace xelf::open-shell)
 (trace xelf::focus-on)
 (trace xelf::close-shell)

(trace switch-to-buffer)
(trace all-buffer-names)
;; (trace xelf::drag-candidate)
;; (trace xelf::drag-maybe)
;; (trace xelf::drag-fail)
;; (trace xelf::hit-inputs)
;; (trace xelf::draw-focus)
(trace xelf::destroy)

(trace xelf::find-root-desktop)
(trace xelf::find-buffer)
(trace xelf::show-root-desktop)
(trace xelf::auto-arrange)
(trace xelf::default-icons)
(trace xelf::populate)

(trace xelf::all-image-names)
(trace xelf::add-node)
(trace xelf::index-all-images)

(trace xelf::glide-window-to)
(trace xelf::snap-windows-to)
(trace xelf::handle-event)
(trace xelf::scroll-tap)
(trace xelf::scroll-position)
(trace xelf::scroll-distance)
(trace xelf::scroll)
(trace xelf::scroll-up)
(trace xelf::scroll-down)
(trace xelf::scroll-left)
(trace xelf::scroll-right)

;; (untrace xelf::layout)
;; (trace xelf::draw-cell)
;; (trace xelf::cell-bounding-box)
;; (trace xelf::draw-empty-cell)
;; (trace xelf::draw-string-in-cell)
;; (trace xelf::draw-row-header)
;; (trace xelf::draw-column-header)

;; (trace xelf::update-window-movement)

(trace xelf::clip)
(trace xelf::resize)
(trace xelf::set-clip-rectangle)

(setf xelf::*shell-enabled-p* t)
(squareball:squareball)

